#!/usr/local/bin/python2.6
#
# Copyright (C) 2009, Oy L M Ericsson Ab, NomadicLab <pubsub@nomadiclab.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as
# published by the Free Software Foundation.
#
# Alternatively, this software may be distributed under the terms of the BSD
# license.
#
# See LICENSE and COPYING for more details.
#

"""PSIRP/Python Object API Example."""

from psirp.libpsirp_py_ import *
from select import *
import sys, time

PUB_LEN = 10000
SID = PSIRP_ID_LEN*'\x00'
RID = psirp_py_atoid("aa::bb")

print("psirp_py_create():")
pub = psirp_py_create(PUB_LEN);
print(pub)

print("\npsirp_py_publish():")
psirp_py_publish(SID, RID, pub)

time.sleep(0.5)

print("\npsirp_py_subscribe():")
spub = psirp_py_subscribe(SID, RID);
print(spub)

print("\npub:")
spub_pub = spub.pub
print(spub_pub)

print("\nbuffer:")
buf = spub.buffer
print(buf)

print("\ndata:")
data = spub.data
print(data)

print("\nlen:")
data_len = spub.len
print(data_len)

print("\nrid:")
rid = spub.rid
print(repr(rid[:]))

print("\nfd:")
fd = spub.fd
print(fd)

print("\ntype:")
spub_type = spub.type
print(spub_type)

print("\naddr:")
addr = spub.addr
print("0x%x" % addr)

# print("\nListening to kevents...:")
# if float(sys.version[:3]) < 2.6:
#     print("Python 2.6 or later required")
# else:
#     map = {fd: spub}
#     kq = kqueue()
#     kq.control([kevent(fd,
#                        KQ_FILTER_VNODE,
#                        KQ_EV_ADD | KQ_EV_CLEAR,
#                        NOTE_PUBLISH | NOTE_SUBSCRIBE,
#                        0,
#                        addr)],
#                0, None)
#     evl = None
#     try:
#         evl = kq.control(None, 1, None)
#         print(evl);
#         if evl is not None and len(evl) > 0 and evl[0].ident in map:
#             print(map[evl[0].ident])
#             evl = None
#     except (KeyboardInterrupt, SystemExit):
#         print(evl)
#     kq.control([kevent(fd,
#                        KQ_FILTER_VNODE,
#                        KQ_EV_DELETE)],
#                0, None)
#     kq.close()

print("\ndel")
del(spub)
