#!/usr/local/bin/python2.6
#
# Copyright (C) 2009, Oy L M Ericsson Ab, NomadicLab <pubsub@nomadiclab.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as
# published by the Free Software Foundation.
#
# Alternatively, this software may be distributed under the terms of the BSD
# license.
#
# See LICENSE and COPYING for more details.
#

"""PSIRP/Python API Read/Write Example."""

from psirp.libpsirp_py_ import *

PUB_LEN = 20000
SID = PSIRP_ID_LEN*'\x00'
RID = psirp_py_atoid("bb::cc")

# Create publication
ppub = psirp_py_create(PUB_LEN);
# Get publication data as buffer
pbuf = ppub.buffer
print('pbuf: %r' % pbuf)
pbuf_len = len(pbuf)

# Write to buffer
pbuf[0], pbuf[pbuf_len-1] = '\xaa', '\x55'
print('pbuf[%d], pbuf[%d]:   %r...%r' \
          % (0, pbuf_len-1, pbuf[0], pbuf[pbuf_len-1]))

# Publish data
psirp_py_publish(SID, RID, ppub)

# Subscribe to data
spub = psirp_py_subscribe(SID, RID)
# Get subscribed data as buffer
sbuf = spub.buffer
print('sbuf: %r' % sbuf)
sbuf_len = len(sbuf)

# Read from buffer
print('sbuf[%d], sbuf[%d]: %r...%r' \
          % (0, sbuf_len-1, sbuf[0], sbuf[sbuf_len-1]))
for i in xrange(0, min(pbuf_len, sbuf_len)):
    if sbuf[i] != pbuf[i]:
        print("published and subscribed data are unequal: %d: %r, %r" \
                  % (i, sbuf[i], pbuf[i]))
        break
else:
    print("published and subscribed data are equal")

pbuf[pbuf_len/2] = '\xff'
print("these should be unequal: pbuf[%d]: %r, sbuf[%d]: %r" \
          % (pbuf_len/2, pbuf[pbuf_len/2], \
                 sbuf_len/2, sbuf[sbuf_len/2]))
