#!/usr/local/bin/python2.6
#
# Copyright (C) 2009, Oy L M Ericsson Ab, NomadicLab <pubsub@nomadiclab.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as
# published by the Free Software Foundation.
#
# Alternatively, this software may be distributed under the terms of the BSD
# license.
#
# See LICENSE and COPYING for more details.
#

from psirp.libpsirp_py import *

PUB_LEN = 20000
SID = PSIRP_ID_LEN*'\x00'
RID = PSIRP_ID_LEN*'A'

# Create publication
print('psirp_create(%d)' % PUB_LEN)
cv = psirp_create(PUB_LEN);
if cv[0] != 0:
    print('psirp_create failed: %r' % cv)
    exit(cv[0])
ppub = cv[1]
del cv

# Get publication data as buffer
print('psirp_py_buffer(%r)' % ppub)
pbuf = psirp_py_buffer(ppub)
print('pbuf: %r' % pbuf)

# Write to buffer
pbuf[0], pbuf[len(pbuf)-1] = '\xaa', '\x55'
print('pbuf[%d], pbuf[%d]:   %r...%r' \
          % (0, len(pbuf)-1, pbuf[0], pbuf[len(pbuf)-1]))

# Publish data
print('psirp_publish(%r, %r, %r)' % (SID, RID, ppub))
pv = psirp_publish(SID, RID, ppub)
if pv != 0:
    print('psirp_publish failed: %r' % pv)
    exit(pv)
del pv

index = len(pbuf)/2
print("pbuf[%d]: %r, modify data (y/n)?" % (index, pbuf[index]))
modify = raw_input()
if modify.lower() == 'y':
    pbuf[index] = '\xff'
    print("pbuf[%d]: %r" % (index, pbuf[index]))

# Free publication
print("psirp_free(%r)" % ppub)
